/**
 * @author zachary
 */
package MemoryMatch 
{
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.text.*;
	import flash.net.*;
	import MemoryMatch.classes.card;
	
	public class MemoryMatch extends Sprite
	{
		private var tokens:Array;
		
		private var match1:card;
		private var match2:card;
		private var turns:int;
		private var matches:int;
		
		private var click:int;
		private var lock:Boolean;
		
		public function MemoryMatch() :void
		{
			stage.stageHeight = 528;//264
			stage.stageWidth = 512;//256
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.frameRate = 12; 
    		
    		showTitle();
		}
		
		private function showTitle():void
		{
			var loader:Loader = new Loader();
			addChild(loader);
			loader.load(new URLRequest('http://divineknightgaming.com/games/hexmatch/images/title.png'));
			loader.x = 10;  
            loader.y = 10;
				
			var playAgain:TextField = new TextField();
	    	playAgain.text = "Play Game";
	    	playAgain.x = 230;
	    	playAgain.y = 260;
	    	playAgain.autoSize = TextFieldAutoSize.LEFT;
	    	playAgain.background = true;
	    	playAgain.backgroundColor = 0X0000CC;
	    	playAgain.textColor = 0Xffffff;
	    	playAgain.border = true;
	    	playAgain.borderColor = 0X000000;
	    	addChild(playAgain);
    		playAgain.addEventListener(MouseEvent.CLICK, restartGame); 
		}
		
		private function setUpGame():void
		{
			click = 1;
    		turns = 0;
    		lock = false;
    		matches = 0;
    		
    		tokens = new Array();
    		
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/bat.png','bat'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/bat.png','bat'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/executioner_evil.png','exec'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/executioner_evil.png','exec'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/ghost.png','ghost'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/ghost.png','ghost'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/skeleton_knight.png','skel_k'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/skeleton_knight.png','skel_k'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/skeleton.png','skel'));
    		tokens.push(new card('http://divineknightgaming.com/games/hexmatch/images/token_back.png','http://divineknightgaming.com/games/hexmatch/images/token_blue.png','http://divineknightgaming.com/games/hexmatch/images/skeleton.png','skel'));
    		
			tokens = randomizeArray(tokens);
			
			addChild(tokens[0]);
			tokens[0].x = 70;
			tokens[0].y = 10;
			tokens[0].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[1]);
			tokens[1].x = 190;
			tokens[1].y = 10; 
			tokens[1].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[2]);
			tokens[2].x = 310;
			tokens[2].y = 10;
			tokens[2].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[3]);
			tokens[3].x = 10;
			tokens[3].y = 116;
			tokens[3].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[4]);
			tokens[4].x = 130;
			tokens[4].y = 116;
			tokens[4].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[5]);
			tokens[5].x = 250;
			tokens[5].y = 116;
			tokens[5].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[6]);
			tokens[6].x = 370;
			tokens[6].y = 116;
			tokens[6].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[7]);
			tokens[7].x = 70;
			tokens[7].y = 222;
			tokens[7].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[8]);
			tokens[8].x = 190;
			tokens[8].y = 222;
			tokens[8].addEventListener(MouseEvent.CLICK, tokenClickListener); 
			addChild(tokens[9]);
			tokens[9].x = 310;
			tokens[9].y = 222;
			tokens[9].addEventListener(MouseEvent.CLICK, tokenClickListener); 
		}
	    
	    private function checkMatch():void
	    {
	    	if(match1.get_name() == match2.get_name())
    		{
    			match1.set_matched();
    			match2.set_matched();
    			matches++;
    			
    			if(matches == tokens.length/2)
    			{
    				createWinMessage();
    			}
    		}
    		else
    		{
    			match1.flip_card();
    			match2.flip_card();
    		}
			lock = false;
	    }
	    
	    private function createWinMessage():void
	    {
	    	var rect:Shape = new Shape();
	    	rect.graphics.lineStyle(1);
	    	rect.graphics.beginFill(0Xffffff,1);
	    	rect.graphics.drawRect(180,150,180,60);
	    	addChild(rect);
	    	
	    	var message:TextField = new TextField();
	    	message.text = "You win. It took you "+turns+" turns.";
	    	message.x = 190;
	    	message.y = 160;
	    	message.autoSize = TextFieldAutoSize.LEFT;
	    	addChild(message);
	    	
	    	var playAgain:TextField = new TextField();
	    	playAgain.text = "Play Again";
	    	playAgain.x = 230;
	    	playAgain.y = 180;
	    	playAgain.autoSize = TextFieldAutoSize.LEFT;
	    	playAgain.background = true;
	    	playAgain.backgroundColor = 0X0000CC;
	    	playAgain.textColor = 0Xffffff;
	    	playAgain.border = true;
	    	playAgain.borderColor = 0X000000;
	    	addChild(playAgain);
    		playAgain.addEventListener(MouseEvent.CLICK, restartGame); 
	    }
	    
	    private function restartGame(e:MouseEvent):void
	    {
	    	while(numChildren > 0)
	    	{
	    		removeChildAt(0);
	    	}
	    	setUpGame();
	    }
	    
	    private function tokenClickListener (e:MouseEvent):void 
	    {
	    	if(lock == false)
	    	{
		    	if(click == 1)
		    	{
		    		match1 = (e.currentTarget as card);
		    		match1.flip_card();
		    		click = 2;
		    	}
		    	else if(click == 2)
		    	{
		    		match2 = (e.currentTarget as card);
		    		if(match1 != match2)
		    		{
		    			lock = true;
			    		match2.flip_card();
			    		click = 1;
			    		turns++;
			    		setTimeout(checkMatch, 1000);
		    		}
		    	}
	    	}
	    }
	    
	    private function randomizeArray(array:Array):Array 
	    {
	        var newArray:Array = new Array();
	        while(array.length > 0)
	        {
	            var obj:Array = array.splice(Math.floor(Math.random()*array.length), 1);
	            newArray.push(obj[0]);
	        }
	        return newArray;
    	}
	    
	}

}